function [simulation_time, Flux_new] = get_rea_flux_data(newfile,SimL,SimInvE,...
    SimInvA,mfmtxt,numcpu,SimDir,set_e, set_a)

use_interp = true;

nech = length(set_e);
na = length(set_a);
fck = dir(newfile);
load(newfile)

try
    parpool(numcpu);
catch end

lt_date = fck.datenum;

sd = simulation_time(1);
ed = simulation_time(end);
hptxt = [];

d_time = simulation_time(2) - simulation_time(1);
time_range = [simulation_time(1) simulation_time(end)];


sz = size(simulation_PSD);
if use_interp
    Flux_new = nan(sz(1),sz(2),nech,na);

	target_L = SimL(:,1,1);
	for ia=1:na
		a_val = set_a(ia) * pi/180;
		for iech=1:nech
			e_val = set_e(iech);

			[new_L, new_epc, new_alpha] = meshgrid(target_L, e_val, a_val);
			new_pc = pfunc(e_val);

			simulation_PSD(simulation_PSD <= 0) = NaN;
			PSD_interpolated = fast_interpolate(SimL,SimInvE,SimInvA, simulation_PSD, new_L, new_epc, new_alpha, 'log');

			new_Flux = NaN(size(PSD_interpolated));
			for it = 1:size(simulation_PSD,1)
				Flux_new(it,:,iech,ia) = PSD_interpolated(it, :) .* new_pc .* new_pc;
			end
		end
	end
end
