function [simulation_time, PSD_new] = get_rea_psd_data(newfile,SimL,SimInvMu,...
    SimInvK,mfmtxt,numcpu,SimDir,set_mus, set_ks)

use_interp = true;

nmu = length(set_mus);
nk = length(set_ks);
fck = dir(newfile);
load(newfile)

try
    parpool(numcpu);
catch end

lt_date = fck.datenum;

sd = simulation_time(1);
ed = simulation_time(end);
hptxt = [];

d_time = simulation_time(2) - simulation_time(1);
time_range = [simulation_time(1) simulation_time(end)];

sz = size(simulation_PSD);
if use_interp
    PSD_new = nan(sz(1),sz(2),nmu,nk);
    parfor it=1:sz(1)
        tpsd = nan(sz(2),nmu,nk);
        for il=1:sz(2)
            psdvec = reshape(simulation_PSD(it,il,:,:),[],1);
            muvec= reshape(SimInvMu(il,:,:),[],1);
            kvec = reshape(SimInvK(il,:,:),[],1);

            F = scatteredInterpolant(log10(muvec),kvec.^(1/3),log10(psdvec));
            F.ExtrapolationMethod = 'none'

            for ik=1:nk
                for im=1:nmu
                    test = F(log10(set_mus(im)),set_ks(ik).^(1/3));
                    tpsd(il,im,ik) = 10.^test;
                end
            end
        end
        PSD_new(it,:,:,:) = tpsd;
    end
    PSD_new = PSD_new ./ 2.997e7;
end
