% Written by Adam C. Kellerman, Jan 2018
% questions should be addressed directly to the Author.
%
% Modified for simple reanalysis, July 2018
% loads reanalysis, based on da_settings file

clear
addpath('../Functions/')

last_file = './Output/bad_flag.mat'; %Forecast_Latest.mat'; % name of file to start from

% start time
t1=datenum(2013,4,1);

% end time
t2=datenum(2013,4,29);

MuVals = [700]; % can be any size
KVals = [0.1]; % can be any size

trng = [t1 t2];
lrng = [1 7];

load_err = false;

% loads reanalysis, based on da_settings
[rea_time,rea_psd,rea_ic] = get_3dda(t1,t2,MuVals,KVals);

nmu = length(MuVals);
nk = length(KVals);

% define the tick marks, default 5 days
tticks = t1:5:t2;

for im = 1:nmu
    for ik = 1:nk

        rpsd = squeeze(rea_psd(:,:,im,ik));
        maxpsd = ceil(log10(max(rpsd(:))));
        minpsd = maxpsd - 4;
        psd_rng = [minpsd maxpsd];

        pcolor(rea_time,rea_ic.SimL(:,1,1),log10(rpsd)')
        xlim(trng)
        c1 = colorbar;
        caxis(psd_rng)
        set(gca,'XTick',tticks)
        shading flat
        colormap(jet(256))
        ylim(lrng);
        ylabel('L*');
        c1.Label.String = 'log_{10} PSD, (c/cm/MeV)^3';

        datetick('x','mmm-dd','keeplimits','keepticks')

        drawnow

        fprintf('Mu = %f, K = %f\n',MuVals(im),KVals(ik));
    end
end

