% Written by Adam C. Kellerman, Jan 2018
% questions should be addressed directly to the Author.
%
% Modified for simple reanalysis, July 2018
% loads reanalysis, based on da_settings file

clear
addpath('../Functions/')

last_file = './Output/bad_flag.mat'; %Forecast_Latest.mat'; % name of file to start from

% start time
t1=datenum(2016,6,1);

% end time
t2=datenum(2016,11,30);

EVals = [0.9]; % can be any size, MeV
AVals = [65]; % can be any size, deg

trng = [t1 t2];
lrng = [1 7];

load_err = false;

% loads reanalysis, based on da_settings
[rea_time,rea_flux,rea_ic] = get_3dda2(t1,t2,EVals,AVals);

nech = length(EVals);
na = length(AVals);

% define the tick marks, default 5 days
tticks = t1:5:t2;

target.en = 0.9;
target.den = 0.2;
target.al = 65;
target.dal = 10; % delta alpha
target.local_pitch_angle = false; 

for iech = 1:nech
    for ia = 1:na
        rflux = squeeze(rea_flux(:,:,iech,ia));
        %maxflux = ceil(log10(max(rflux(:))));
        %minflux = maxflux - 6;
        %flux_rng = [minflux maxflux];
        ax = gca;
        ax.Color = 'black';
        %colormap(jet);
        pcolor(rea_time,rea_ic.SimL(:,1,1),log10(rflux)');
        %scatter(rea_time,rea_ic.SimL(:,1,1),log10(rflux)');
        xlim(trng)
        c1 = colorbar;
        ax.CLim = [-2 4];
        %caxis(flux_rng)
        set(gca,'XTick',tticks)
        shading flat
        colormap(jet(256));
        ylim(lrng);
        ylabel('L*, T89');
        xlabel('Date');
        c1.Label.String = 'Log_{10}(Flux), (cm^2 s sr keV)^{-1}';

        datetick('x','mm/dd','keeplimits','keepticks');
title(sprintf('Calibrated binned POES data reanalysis, \\alpha = %d\\circ, Energy = %.1f MeV',...
    target.al,target.en));
        drawnow

        fprintf('E = %f MeV, A = %f deg\n',EVals(iech),AVals(ia));
    end
end

%    hold on;    
%end
%    hold off;

%    ax = gca;
%    cb = colorbar;
%    ylabel(cb, 'Log_{10}(Flux), (cm^2 s sr keV)^{-1}');
%    ax.YLim = [1 7];
%    ax.Color = 'black';
%    colormap(jet);
%    ax.CLim = [-2 4];
%    ylabel('L*, T89');
%    xlabel('Date');
%    datetick('x','mm/dd','keeplimits','keepticks');