% NOTE:
% This function is under active development
% A lot of functionality will be moved to separate functions
% There is no cachingor savind data. Also, ituses expisit path to the
% existing data that has to be chnaged accordint to the used computer

clear
addpath('../Functions/')

%% load rbsp data
%data_path = 'e:\Grants\19.10 SSI\codes\Survay plots\';
data_path = 'g:\My Drive\Grants\19.10 SSI\codes\Survay plots\';

% Note that data is prepared in saved file
% load only one satellite for now. RBSP
sat = 'rbspa';
sdata_psd = load([data_path 'sdata_psd.mat'], [sat '_psd']);
sdata = load([data_path 'sdata.mat'], sat);
% renaming variable. Should be fast enought
sdata_psd = sdata_psd.([sat '_psd']);
sdata = sdata.(sat);

% Check the data
if numel(sdata.Time.arr) == numel(sdata_psd.Time.arr) && ...
        all(sdata.Time.arr == sdata_psd.Time.arr)
else
    error('Time arrays are different. Check the loaded data.');
end
%% setup the parameters
% start time
t1=datenum(2013,4,2);
% end time
t2=datenum(2013,4,30);

Eval = 0.9; % MeV - closes energy will be selected
Aval = 90; % deg - local pitch angle (!)

% Process satellite pass
Energy = mean(sdata.Energy.arr,'omitnan'); % compress the energy in time (this processing is data dependent. we don't do additional check)
Alpha = rad2deg(mean(sdata.AlphaLocal.arr,'omitnan')); % compress the alpha in time (this processing is data dependent. we don't do additional check)
[~,eidx] = min(abs(Energy - Eval)); % Select energy channel
[~,aidx] = min(abs(Alpha - Aval)); % Select energy channel
% Select valid data
tidx = sdata.Time.arr >= t1 & sdata.Time.arr <= t2;
idx = tidx & ~isnan(sdata.Energy.arr(:,eidx)) & ~isnan(sdata.AlphaLocal.arr(:,aidx));

Time = sdata.Time.arr(idx);
Flux = sdata.Flux.arr(idx,eidx,aidx);
Mu = sdata_psd.InvMu.arr(idx,eidx,aidx);
K = sdata_psd.InvK.arr(idx,aidx);
Lstar = sdata.Lstar.arr(idx,aidx);
%%
Flux_DA = NaN(size(Flux));

% Get reanalisys data
fcopt = da_settings; 
base_rea_dir = [getenv('HOME'),'/projects/rb-da-framework/3DDA/'];
% create named variables based on settings
[fcopt] = get_sim_dir(fcopt);
disp(fcopt.simulation_dir);

% This is extra step that can be avoided
folder = [fcopt.simulation_dir,'Output/'];
try
    [L, epc, alpha, pc] = load_plt([folder, 'perp_grid.plt']);
catch
    error('%s does not exist!',folder);
end
sim.grid.L = L.arr;
sim.grid.pc = pc.arr;
sim.grid.al = alpha.arr;

% Convert to invariants using dipole
sim.grid.Mu = pc2mu(L.arr,pc.arr,alpha.arr);
sim.grid.K = Lalpha2K(L.arr,alpha.arr);

date_load = t1;
date_end = t2;
tic
while date_load <= date_end
    fdate = datestr(date_load,'yyyymmdd');
    yrmo = datestr(date_load,'yyyymm');
    rea_file = [fcopt.simulation_dir,'Archive/',yrmo,'/PSD_3DDA_',fdate,'.mat'];
    fprintf('getting psd for %s, last: %s...',fdate, datestr(date_end,'yyyymmdd'));
    if isfile(rea_file)        
        sim.data = load(rea_file);
        fprintf('ok...');
    else
        fprintf('no file\n');
        date_load = date_load + 1;
        continue;
    end
    
    % file is loadded, now it is time to process it    
    tidx = Time >= sim.data.simulation_time(1) &...
        Time <= sim.data.simulation_time(end);
    
    % Create variables for selected time.
    Time_DA_day = Time(tidx);
    Flux_DA_day = Flux_DA(tidx);
    Mu_DA_day = log10(Mu(tidx));
    K_DA_day = log10(K(tidx));
    Lstar_DA_day = Lstar(tidx);
    
    % set limiter for K, otherwise interpolation produces spikes
    K_DA_day(K_DA_day < -5) = -5;
    
%    % Nearest search
%     for it = 1:numel(Time_DA_day) % make it parfor in the future
%         % let start with simple approach
%         
%         % index of the simluation time
%         [~,stidx] = min(abs(sim.data.simulation_time - Time_DA_day(it)));
% %       
%         % So far without interpolation
%         [~,slidx] = min(abs(sim.grid.L(:,1,1) - Lstar_DA_day(it)));
%         
%         % No interpolation        
%         [~,saidx] = min(abs(log10(sim.grid.K(slidx,1,:)) - K_DA_day(it)));
%         [~,smidx] = min(abs(log10(sim.grid.Mu(slidx,:,saidx)) - Mu_DA_day(it)));
%         Flux_DA_day(it) = sim.data.simulation_PSD(stidx, slidx, smidx, saidx) .* sim.grid.pc(slidx, smidx, saidx) .^ 2;
%     end

%    % 2D intepolation
%    % prepare variables for parfor
%     grid_L = sim.grid.L;
%     grid_Mu = log10(sim.grid.Mu);
%     grid_K = log10(sim.grid.K);
%     grid_pc = log10(sim.grid.pc);
%     sim_PSD = log10(sim.data.simulation_PSD);
%     sim_time = sim.data.simulation_time;
%     parfor it = 1:numel(Time_DA_day) % make it parfor in the future
%         % index of the simluation time
%         [~,stidx] = min(abs(sim_time - Time_DA_day(it)));
%         [~,slidx] = min(abs(grid_L(:,1,1) - Lstar_DA_day(it)));
%                 
%         % 2d interpolation
%         Mu_arr = grid_Mu(slidx,:,:);
%         K_arr = grid_K(slidx,:,:);
%         PSD_arr = sim_PSD(stidx, slidx, :, :);
%         pc_arr = grid_pc(slidx, :, :);
%         psd_int = scatteredInterpolant(Mu_arr(:), K_arr(:), PSD_arr(:));
%         pc_int = scatteredInterpolant(Mu_arr(:), K_arr(:), pc_arr(:));
%         
%         Flux_DA_day(it) = 10.^psd_int(Mu_DA_day(it), K_DA_day(it)) .* (10.^pc_int(Mu_DA_day(it), K_DA_day(it))) .^ 2;
%     end

%    % 3d interpolation
    % prepare variables for parfor
    grid_L = sim.grid.L(:);
    grid_Mu = log10(sim.grid.Mu(:));
    grid_K = log10(sim.grid.K(:));
    grid_pc = log10(sim.grid.pc(:));
    sim_PSD = log10(sim.data.simulation_PSD);
    sim_time = sim.data.simulation_time;
    % prepare independent variables for parfor loop
    Flux_DA_day_cell = cell(numel(sim_time),1);
    Lstar_DA_day_cell = cell(numel(sim_time),1);
    Mu_DA_day_cell = cell(numel(sim_time),1);
    K_DA_day_cell = cell(numel(sim_time),1);
    stidx_DA_day_cell = cell(numel(sim_time),1);
    for it = 1:numel(sim_time)-1
       stidx = Time_DA_day >= sim_time(it) & Time_DA_day <= sim_time(it+1);
       stidx_DA_day_cell{it} = stidx;
       Lstar_DA_day_cell{it} = Lstar_DA_day(stidx);
       Mu_DA_day_cell{it} = Mu_DA_day(stidx);
       K_DA_day_cell{it} = K_DA_day(stidx);
    end
    
    parfor it = 1:numel(sim_time)-1
       if ~any(stidx_DA_day_cell{it}), continue; end % if we don't have data - move on
       PSD_arr = sim_PSD(it, :, :, :);
       PSD_int = scatteredInterpolant(grid_L, grid_Mu, grid_K, PSD_arr(:));
       pc_int = scatteredInterpolant(grid_L, grid_Mu, grid_K, grid_pc);
              
       Flux_DA_day_cell{it} = 10.^PSD_int(Lstar_DA_day_cell{it}, Mu_DA_day_cell{it}, K_DA_day_cell{it})...
           .* (10.^pc_int(Lstar_DA_day_cell{it},  Mu_DA_day_cell{it}, K_DA_day_cell{it})) .^ 2;
    end
    
    % collect data back togeather
    for it = 1:numel(sim_time)-1   
        Flux_DA_day( stidx_DA_day_cell{it} ) = Flux_DA_day_cell{it};
    end    


    % save flux of the day
    Flux_DA(tidx) = Flux_DA_day;
    % next step
    date_load = date_load + 1;
    fprintf('done, %f\n', toc); 
end
%% Plot
% define the tick marks, default 5 days

tticks = t1:4:t2;

%  t1 = datenum(2013,04,15); % 2 15 23
%  t2 = datenum(2013,04,15+5);
%  tticks = t1:1:t2;

figure('Position',[100 100 1200 900],'defaultAxesFontWeight','bold','defaultAxesFontSize',12,...
'InvertHardcopy','off','Color','white');

ax = subplot(2,1,1);
plot(Time, Flux,'.-'); hold on
plot(Time, Flux_DA,'.-'); hold on
legend('RBSPA','POES DA');

%title(sprintf('%s and DA POES,  \\alpha_{loc} = %.0f\\circ, Energy = %.1f MeV ',...
title(sprintf('%s and DA POES (no daily variations),  \\alpha_{loc} = %.0f\\circ, Energy = %.1f MeV ',...
    sat,Alpha(aidx),Energy(eidx)));
ax.XTick = tticks;
ax.YScale = 'log';
ax.YLim = 10.^[-1 4];
datetick('x','mm/dd','keeplimits','keepticks'); grid on;
ylabel('Flux, 1/cm^2/s/sr/keV');

idx = (log10(Flux) >= -2) & (log10(Flux_DA) >= -2);

ax2 = subplot(2,1,2);
plot(Time(idx), log10(Flux(idx)) - log10(Flux_DA(idx)));
ax2.XTick = tticks;
datetick('x','mm/dd','keeplimits','keepticks');
linkaxes([ax ax2],'x'); grid on;
ax.XLim = [t1 t2];
ylabel('log_{10}(Flux_{rbsp}/Flux_{DA})');
ax2.YTick = [-5:1:5];




