% Simulation loop script, loops through each day
% written by A. C. Kellerman
% 
% This script creates daily 3DDA files, based on inputs in the fcopt structure
% Only new files are created, unless fcopt.recompute is set to true.
% run settings file

clear
setenv('FC_3DDA_DIR','/home/kirill/git/simple-da-framework/3DDA')
setenv('FC_DATA_DIR','/home/kirill/data')
setenv('FC_NUMCPU','4')

addpath('../Functions/')

fcopt = da_settings;

% create named variables based on settings
[fcopt]=get_sim_dir(fcopt);

try
    parpool(fcopt.numcpu);
catch end

last_file = 'bad_file.mat';

c_date = fcopt.da_start_date;
while c_date < fcopt.da_end_date

    ayrmo = datestr(c_date,'yyyymm');
    fcopt.arc_dir = [fcopt.simulation_dir,'Archive/',ayrmo,'/'];
    fcopt.c_date = c_date;

    fdate = datestr(c_date,'yyyymmdd');
    fcopt.output_file = [fcopt.arc_dir,'PSD_3DDA_',fdate,'.mat'];

    fck = dir(last_file);
    if isempty(fck)
        fcopt.restart_simulation = false;
    else
        fcopt.restart_simulation = true;
        fcopt.restart_file = last_file;
    end
    fprintf('date: %s\n',fdate);     
    rcp = false;
    if fcopt.recompute
        if c_date >= fcopt.restart_date
            rcp = true;
        end
    end

    fck = dir(fcopt.output_file);
    if isempty(fck) || rcp
        da3d(fcopt);
    end
    last_file = fcopt.output_file;

    c_date = c_date + 1;
end
