function Interp_Dxx(simulation_dir,Dxx_opt)

% Correct, so Dap^2 < correction_coeff * Daa * Dpp
do_corr = true
correction_coeff = 0.90;%0.99;

max_L_error = 0.2;
%max_L_error = 0.2;

% 
do_smooth = false
do_plot = false % may not render correctly with Octave
do_pic = false
c_min = -6; 
c_max = 2;

% L-value to plot the resulted coefficients for comparison (in 3D case)
%L_value = 3.5;
L_value = 4.5;

if Dxx_opt == 1
    Dxx_file_arr = {
    {'./VERB/Original/Hiss_Typical/DC_Typical_Hiss_Ksenia.plt', 'Hiss'},
    {'./VERB/Original/Chorus_Day/DC_Chorus_Dayside_Ksenia.plt', 'Chorus_Day'},
    {'./VERB/Original/Chorus_Night/DC_Chorus_Nightside_Ksenia.plt', 'Chorus_Night'}    
    };
elseif Dxx_opt == 2
    Dxx_file_arr = {
    {'./VERB/Original/Hiss_KS14/DC_Hiss_KS14_Ksenia.plt', 'Hiss'},
    {'./VERB/Original/Chorus_Day/DC_Chorus_Dayside_Ksenia.plt', 'Chorus_Day'},
    {'./VERB/Original/Chorus_Night/DC_Chorus_Nightside_Ksenia.plt', 'Chorus_Night'}    
    };
elseif Dxx_opt == 3
    Dxx_file_arr = {
    {'./VERB/Original/Hiss_2016/DC_Hiss_2016_Ksenia.plt', 'Hiss'},
    {'./VERB/Original/Chorus_Day_2016/DC_Chorus_Dayside_2016.plt', 'Chorus_Day'},
    {'./VERB/Original/Chorus_Night_2016/DC_Chorus_Nightside_2016.plt', 'Chorus_Night'}    
    };
elseif Dxx_opt == 4
    Dxx_file_arr = {
    {'./VERB/Original/Hiss_Typical/DC_Typical_Hiss_Ksenia.plt', 'Hiss'},
    {'./VERB/Original/Binbin_Version/Chorus_Day/DC_Chorus_Dayside_L1-7_Binbin.plt',...
        'Chorus_Day'},
    {'./VERB/Original/Binbin_Version/Chorus_Night/DC_Chorus_Nightside_L1-7_Binbin.plt',...
        'Chorus_Night'}
    };
else
    error('unknown dxx option %i',Dxx_opt);
end
simulation_dir
% the perp_grid.plt file that we want to use
gridFileName = [simulation_dir,'Output/perp_grid.plt'];

% where we will save the new coefficients and perp grid file
output_dir = [simulation_dir,'DiffCoeff/'];

for i = 1:size(Dxx_file_arr,1)
    Dxx_file = Dxx_file_arr{i}{1}
    postfix = ['_', Dxx_file_arr{i}{2}]; % ending of filename to save

    tic

    fprintf('loading %s...', Dxx_file)
    try % For Octave output
        fflush(stdout);
    catch end
    [L,epc,alpha,Daa,Dpp,Dpa] = load_plt(Dxx_file, 'permute', 'squeeze', 'make3D');
    fprintf('done\n')
    try % For Octave output
        fflush(stdout);
    catch end

    epc.arr = epc.arr / 10^3; % To MeV
    alpha.arr = alpha.arr * pi ./ 180; % to Rad

    % adding grid points at alpha=0, alpha=90, and energy=0.01MeV
    if (false)
        % adding 0 and pi/2
        alpha_size = size(alpha.arr,3);
        alpha.arr(:,:,[2:alpha_size+1]) = alpha.arr;
        alpha.arr(:,:,alpha_size+2) = pi/2;
        alpha.arr(:,:,1) = 0;
        % grid is uniform
        epc.arr(:,:,[3:alpha_size+2]) = epc.arr;
        Daa.arr(:,:,[2:alpha_size+1]) = Daa.arr;
        Daa.arr(:,:,alpha_size+2) = Daa.arr(:,:,alpha_size);
        Dpa.arr(:,:,[2:alpha_size+1]) = Dpa.arr;
        Dpa.arr(:,:,alpha_size+2) = Dpa.arr(:,:,alpha_size);
        Dpp.arr(:,:,[2:alpha_size+1]) = Dpp.arr;
        Dpp.arr(:,:,alpha_size+2) = Dpp.arr(:,:,alpha_size);

        % adding min energy
        epc_size = size(epc.arr,2);
        epc.arr(:,[2:epc_size+1],:) = epc.arr;
        epc.arr(:,1,:) = 0.01;
        % grid is uniform
        alpha.arr(:,[2:epc_size+1],:) = alpha.arr;
        Daa.arr(:,[2:epc_size+1],:) = Daa.arr;
        Dpa.arr(:,[2:epc_size+1],:) = Dpa.arr;
        Dpp.arr(:,[2:epc_size+1],:) = Dpp.arr;
    end

    [new_L, new_epc, new_alpha, new_pc] = load_plt(gridFileName, 'permute', 'make3D');
    new_L_size = size(new_L.arr, 1);
    new_epc_size = size(new_epc.arr, 2);
    new_alpha_size = size(new_alpha.arr, 3);

    %Daa
    if (true)
        %        Daa_new = Daa;
        %Daa_new.name = strrep(Daa.name, '_(Day)', '');
        %Daa_new.name = strrep(Daa_new.name, '_Day', '');
        %Daa_new.name = [Daa_new.name, postfix];
        Daa_new.name = ['Daa', postfix];
        Daa_new.fname = [strrep(Daa_new.name, ' ', '_'), '_Full_LPA'];
        Daa_new.comments = [Daa.comments, ['# File: ', pwd, Dxx_file]];
        %Daa_new.arr = zeros(size(new_L.arr));
        tmp_arr = zeros(size(new_L.arr))+1e-10; 
        parfor il = 1:new_L_size
            
            if ( new_L.arr(il,1,1) <= max(L.arr(:,1,1)) && new_L.arr(il,1,1) >= min(L.arr(:,1,1)) )
            
                [tmp, L_slice] = min(abs(L.arr(:,1,1) - new_L.arr(il,1,1)));
                loop_counter(il,new_L_size,'tput','pretext','Daa L Slice: ');
                try % For Octave output
                    fflush(stdout);
                catch end
                if (tmp > max_L_error)
                    error('L grid mismatch\n')
                end
                
                % I don't know what 'Qt' means, but it works this way and
                % does not work without. Look matlab help.
            
                Gepc = reshape(epc.arr(L_slice,:,:),size(epc.arr(L_slice,:,:),2),size(epc.arr(L_slice,:,:),3)); 
                Galpha = reshape(alpha.arr(L_slice,:,:),size(alpha.arr(L_slice,:,:),2),size(alpha.arr(L_slice,:,:),3));
                GDaa = reshape(Daa.arr(L_slice,:,:),size(Daa.arr(L_slice,:,:),2),size(Daa.arr(L_slice,:,:),3));
                Gnew_epc = reshape(new_epc.arr(il,:,:),size(new_epc.arr(il,:,:),2),size(new_epc.arr(il,:,:),3));
                Gnew_alpha = reshape(new_alpha.arr(il,:,:),size(new_alpha.arr(il,:,:),2),size(new_alpha.arr(il,:,:),3));
            
                %Daa_new.arr(il, :, :) = griddata(Gepc, Galpha, GDaa, Gnew_epc, Gnew_alpha, 'linear');%, {'QJ'});
                tmp = griddata(Gepc, Galpha, GDaa, Gnew_epc, Gnew_alpha, 'linear');%, {'QJ'});
                tmp_arr(il, :, :) = tmp; %griddata(Gepc, Galpha, GDaa, Gnew_epc, Gnew_alpha, 'linear');%, {'QJ'});
            
            end
        end
        Daa_new.arr = tmp_arr;
        
        Daa_new.arr(find(isnan(Daa_new.arr))) = 1e-10;
        Daa_new.arr(Daa_new.arr<1e-10) = 1e-10;
        if (do_smooth) Daa_new.arr = smooth2(Daa_new.arr, 1, 10); end;

        save_plt_lpa([output_dir, '', Daa_new.fname, '.plt'], new_L, new_epc, new_alpha, Daa_new);

        if (do_plot)

            f1 = figure('Units', 'inches', 'Position', [0.5 0.5 12 5], ...
                'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 12, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 12,...
                'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%


            subplot(1,2,1)

            [tmp, L_slice] = min(abs(new_L.arr(:,1,1)-L_value));

            Dxx_plot = log10(squeeze(Daa_new.arr(L_slice,:,:)));
            Dxx_plot(isnan(Dxx_plot)) = c_min;
            Dxx_plot(find(Dxx_plot<c_min)) = c_min;
            pcolor(squeeze(new_alpha.arr(L_slice,:,:))*180/pi, squeeze(new_epc.arr(L_slice,:,:)), Dxx_plot);
            %pcolor(squeeze(new_alpha.arr(L_slice,:,:)), squeeze(new_epc.arr(L_slice,:,:)), squeeze(Daa_new.arr(L_slice,:,:)));
            shading flat
            set(gca, 'yscale', 'log')
            yl = ylim;
            xlim([0 90])
            caxis([c_min c_max])
            col = caxis;
            colorbar
            xlabel('Pitch angle, deg')
            ylabel('Energy, MeV')
            text(max(xlim), max(ylim), ['L=', num2str(new_L.arr(L_slice,1,1))], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');
            text(min(xlim), max(ylim), ['D_{aa}, ', name2title(Dxx_file_arr{i}{2})], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');

            subplot(1,2,2)

            [tmp, L_slice] = min(abs(L.arr(:,1,1)-new_L.arr(L_slice, 1, 1)));

            Dxx_plot = log10(squeeze(Daa.arr(L_slice,:,:)));
            Dxx_plot(isnan(Dxx_plot)) = c_min;
            Dxx_plot(find(Dxx_plot<c_min)) = c_min;
            pcolor(squeeze(alpha.arr(L_slice,:,:))*180/pi, squeeze(epc.arr(L_slice,:,:)), Dxx_plot);
            %pcolor(squeeze(alpha.arr(L_slice,:,:)), squeeze(epc.arr(L_slice,:,:)), squeeze(Daa.arr(L_slice,:,:)));
            shading flat
            set(gca, 'yscale', 'log')
            ylim(yl)
            xlim([0 90])
            caxis(col)
            colorbar
            xlabel('Pitch angle, deg')
            text(max(xlim), max(ylim), ['L=', num2str(L.arr(L_slice,1,1))], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');
            
            
            if (do_pic)
                saveas(gcf,['Daa', name2title(Dxx_file_arr{i}{2}) '.jpg']);
            end;

        end
    end

    %Dpp
    if (true)
        %        Dpp_new = Dpp;
        %Dpp_new.name = strrep(Dpp.name, '_Day', '');
        %Dpp_new.name = strrep(Dpp_new.name, '_(Day)', '');
        %Dpp_new.name = [Dpp_new.name, postfix];
        Dpp_new.name = ['Dpp', postfix];
        Dpp_new.fname = [strrep(Dpp_new.name, ' ', '_'), '_Full_LPA'];
        Dpp_new.comments = [Dpp.comments, ['# File: ', pwd, Dxx_file]];
        %Dpp_new.arr = zeros(size(new_L.arr));
        tmp_arr = zeros(size(new_L.arr))+1e-10;

        parfor il = 1:new_L_size
            if ( new_L.arr(il,1,1) <= max(L.arr(:,1,1)) && new_L.arr(il,1,1) >= min(L.arr(:,1,1)) )
            
                [tmp, L_slice] = min(abs(L.arr(:,1,1) - new_L.arr(il,1,1)));
                loop_counter(il,new_L_size,'tput','pretext','Dpp L Slice: ');
                try % For Octave output
                    fflush(stdout);
                catch end
                if (tmp > max_L_error)
                        error('L grid mismatch\n')
                end
                
                Gepc = reshape(epc.arr(L_slice,:,:),size(epc.arr(L_slice,:,:),2),size(epc.arr(L_slice,:,:),3));
                Galpha = reshape(alpha.arr(L_slice,:,:),size(alpha.arr(L_slice,:,:),2),size(alpha.arr(L_slice,:,:),3));
                GDpp = reshape(Dpp.arr(L_slice,:,:),size(Dpp.arr(L_slice,:,:),2),size(Dpp.arr(L_slice,:,:),3));
                Gnew_epc = reshape(new_epc.arr(il,:,:),size(new_epc.arr(il,:,:),2),size(new_epc.arr(il,:,:),3));
                Gnew_alpha = reshape(new_alpha.arr(il,:,:),size(new_alpha.arr(il,:,:),2),size(new_alpha.arr(il,:,:),3));
                
                %Dpp_new.arr(il, :, :) = griddata(Gepc, Galpha, GDpp, Gnew_epc, Gnew_alpha, 'linear');%, {'QJ'});
                tmp_arr(il, :, :) = griddata(Gepc, Galpha, GDpp, Gnew_epc, Gnew_alpha, 'linear');%, {'QJ'});
            
             end;
            %Dpp_new.arr(il, :, :) = griddata(epc.arr(L_slice,:,:), alpha.arr(L_slice,:,:), Dpp.arr(L_slice,:,:), new_epc.arr(il,:,:), new_alpha.arr(il,:,:), 'linear');%, {'QJ'});
        end
        Dpp_new.arr = tmp_arr;

        Dpp_new.arr(find(isnan(Dpp_new.arr))) = 1e-10;
        Dpp_new.arr(Dpp_new.arr<1e-10) = 1e-10;
        if (do_smooth) Dpp_new.arr = smooth2(Dpp_new.arr, 1, 10); end;
        save_plt_lpa([output_dir, '', Dpp_new.fname, '.plt'], new_L, new_epc, new_alpha, Dpp_new);

        if (do_plot)

            f1 = figure('Units', 'inches', 'Position', [0.5 0.5 12 5], ...
                'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 12, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 12,...
                'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%


            subplot(1,2,1)

            [tmp, L_slice] = min(abs(new_L.arr(:,1,1)-L_value));

            Dxx_plot = log10(squeeze(Dpp_new.arr(L_slice,:,:)));
            Dxx_plot(isnan(Dxx_plot)) = c_min;
            Dxx_plot(find(Dxx_plot<c_min)) = c_min;
            pcolor(squeeze(new_alpha.arr(L_slice,:,:))*180/pi, squeeze(new_epc.arr(L_slice,:,:)), Dxx_plot);
            %pcolor(squeeze(new_alpha.arr(L_slice,:,:)), squeeze(new_epc.arr(L_slice,:,:)), squeeze(Daa_new.arr(L_slice,:,:)));
            shading flat
            set(gca, 'yscale', 'log')
            yl = ylim;
            xlim([0 90])
            caxis([c_min c_max])
            col = caxis
            colorbar
            xlabel('Pitch angle, deg')
            ylabel('Energy, MeV')
            text(max(xlim), max(ylim), ['L=', num2str(new_L.arr(L_slice,1,1))], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');
            text(min(xlim), max(ylim), ['D_{pp}, ', name2title(Dxx_file_arr{i}{2})], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');

            subplot(1,2,2)

            [tmp, L_slice] = min(abs(L.arr(:,1,1)-new_L.arr(L_slice, 1, 1)));

            Dxx_plot = log10(squeeze(Dpp.arr(L_slice,:,:)));
            Dxx_plot(isnan(Dxx_plot)) = c_min;
            Dxx_plot(find(Dxx_plot<c_min)) = c_min;
            pcolor(squeeze(alpha.arr(L_slice,:,:))*180/pi, squeeze(epc.arr(L_slice,:,:)), Dxx_plot);
            %pcolor(squeeze(alpha.arr(L_slice,:,:)), squeeze(epc.arr(L_slice,:,:)), squeeze(Daa.arr(L_slice,:,:)));
            shading flat
            set(gca, 'yscale', 'log')
            ylim(yl)
            xlim([0 90])
            caxis(col)
            colorbar
            xlabel('Pitch angle, deg')
            text(max(xlim), max(ylim), ['L=', num2str(L.arr(L_slice,1,1))], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');
            
             if (do_pic)
                saveas(gcf,['Dpp', name2title(Dxx_file_arr{i}{2}) '.jpg']);
             end;

        end

    end

    %Dpa
    if(true)
        %        Dpa_new = Dpa;
        %Dpa_new.name = strrep(Dpa.name, '_Day', '');
        %Dpa_new.name = strrep(Dpa_new.name, '_(Day)', '');
        %Dpa_new.name = [Dpa_new.name, postfix];
        Dpa_new.name = ['Dap', postfix];
        Dpa_new.fname = [strrep(Dpa_new.name, ' ', '_'), '_Full_LPA'];
        Dpa_new.comments = [Dpa.comments, ['# File: ', pwd, Dxx_file]];
        %Dpa_new.arr = zeros(size(new_L.arr));
        tmp_arr = zeros(size(new_L.arr));
        
        parfor il = 1:new_L_size
            
            if ( new_L.arr(il,1,1) <= max(L.arr(:,1,1)) && new_L.arr(il,1,1) >= min(L.arr(:,1,1)) )
            
                [tmp, L_slice] = min(abs(L.arr(:,1,1) - new_L.arr(il,1,1)));
                loop_counter(il,new_L_size,'tput','pretext','Dpa L Slice: ');
                try % For Octave output
                    fflush(stdout);
                catch end
                if (tmp > max_L_error)
                        error('L grid mismatch\n')
                end
                
                Gepc = reshape(epc.arr(L_slice,:,:),size(epc.arr(L_slice,:,:),2),size(epc.arr(L_slice,:,:),3)); 
                Galpha = reshape(alpha.arr(L_slice,:,:),size(alpha.arr(L_slice,:,:),2),size(alpha.arr(L_slice,:,:),3));
                GDpa = reshape(Dpa.arr(L_slice,:,:),size(Dpa.arr(L_slice,:,:),2),size(Dpa.arr(L_slice,:,:),3));
                Gnew_epc = reshape(new_epc.arr(il,:,:),size(new_epc.arr(il,:,:),2),size(new_epc.arr(il,:,:),3));
                Gnew_alpha = reshape(new_alpha.arr(il,:,:),size(new_alpha.arr(il,:,:),2),size(new_alpha.arr(il,:,:),3));
                
                %Dpa_new.arr(il, :, :) = griddata(Gepc, Galpha, GDpa, Gnew_epc, Gnew_alpha, 'linear');%, {'QJ'});
                tmp_arr(il, :, :) = griddata(Gepc, Galpha, GDpa, Gnew_epc, Gnew_alpha, 'linear');%, {'QJ'});
            
            end;
            %Dpa_new.arr(il, :, :) = griddata(epc.arr(L_slice,:,:), alpha.arr(L_slice,:,:), Dpa.arr(L_slice,:,:), new_epc.arr(il,:,:), new_alpha.arr(il,:,:), 'linear');%, {'QJ'});
        end

        Dpa_new.arr = tmp_arr;
        Dpa_new.arr(find(isnan(Dpa_new.arr))) = 0;
        if (do_smooth) Dpa_new.arr = smooth2(Dpa_new.arr, 1, 10); end;

        % correct Dpa where Dpa^2 > Daa*Dpp*correction_coeff
        if (do_corr)
            total_correction = 0;
            tmp = Dpa_new.arr;
            diff = find((Dpa_new.arr.*Dpa_new.arr) ./ (Daa_new.arr.*Dpp_new.arr) >= correction_coeff);
            Dpa_new.arr(diff) = sign(Dpa_new.arr(diff)).*(sqrt(Daa_new.arr(diff).*Dpp_new.arr(diff))*correction_coeff);
            total_correction = sum(sum(abs(tmp - Dpa_new.arr)))/(size(Dpa_new.arr,1)*size(Dpa_new.arr,2));
            %Dpa_new.comments = [Dpa_new.comments, ['# Corrected to satisfy Dpp*Daa>Dpa^2 (in average): ', num2str(total_correction), ' per point']];
        end;

        save_plt_lpa([output_dir, '', Dpa_new.fname, '.plt'], new_L, new_epc, new_alpha, Dpa_new);

        if (do_plot)
%% Run for plot


            f1 = figure('Units', 'inches', 'Position', [0.5 0.5 12 5], ...
                'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 12, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 12,...
                'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%


            subplot(1,2,1)

            [tmp, L_slice] = min(abs(new_L.arr(:,1,1)-L_value));

            Dxx_plot = log10(abs(squeeze(Dpa_new.arr(L_slice,:,:))));
            Dxx_plot(isnan(Dxx_plot)) = c_min;
            Dxx_plot(find(Dxx_plot<c_min)) = c_min;
            pcolor(squeeze(new_alpha.arr(L_slice,:,:))*180/pi, squeeze(new_epc.arr(L_slice,:,:)), Dxx_plot);
            %pcolor(squeeze(new_alpha.arr(L_slice,:,:)), squeeze(new_epc.arr(L_slice,:,:)), squeeze(Daa_new.arr(L_slice,:,:)));
            shading flat
            set(gca, 'yscale', 'log')
            yl = ylim;
            xlim([0 90])
            caxis([c_min c_max])
            col = caxis
            colorbar
            xlabel('Pitch angle, deg')
            ylabel('Energy, MeV')
            text(max(xlim), max(ylim), ['L=', num2str(new_L.arr(L_slice,1,1))], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');
            text(min(xlim), max(ylim), ['D_{pa}, ', name2title(Dxx_file_arr{i}{2})], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');

            subplot(1,2,2)

            [tmp, L_slice] = min(abs(L.arr(:,1,1)-new_L.arr(L_slice, 1, 1)));

            Dxx_plot = log10(abs(squeeze(Dpa.arr(L_slice,:,:))));
            Dxx_plot(isnan(Dxx_plot)) = c_min;
            Dxx_plot(find(Dxx_plot<c_min)) = c_min;
            pcolor(squeeze(alpha.arr(L_slice,:,:))*180/pi, squeeze(epc.arr(L_slice,:,:)), Dxx_plot);
            %pcolor(squeeze(alpha.arr(L_slice,:,:)), squeeze(epc.arr(L_slice,:,:)), squeeze(Daa.arr(L_slice,:,:)));
            shading flat
            set(gca, 'yscale', 'log')
            ylim(yl)
            xlim([0 90])
            caxis(col)
            colorbar
            xlabel('Pitch angle, deg')
            text(max(xlim), max(ylim), ['L=', num2str(L.arr(L_slice,1,1))], 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', 14, 'Color', 'black');
            
        
             if (do_pic)
                saveas(gcf,['Dpa', name2title(Dxx_file_arr{i}{2}) '.jpg']);
             end;

        end

    end

    toc
    try % For Octave output
        fflush(stdout);
    catch end
end

% copy the grid file to the output directory
% this ensures that we have the right diffusion coefficients available

copyfile(gridFileName,output_dir);
end
