function [Kp] = Load_Kp2(time1,time2)
%Load_Kp2  Loads Kp-index based on omniwebdata
% time1 - start date in datenum. 
% time2 - end date in datenum
% note that omniwebdata loads data of the whole day.
% Returns structure with 'kp_time' and 'kp_index' fields.

[~, omniKp] = omniwebdata(time1,time2, 38);
Kp=struct('kp_time',omniKp.time,'kp_index',omniKp.arr./10);

end

