%% Load_kp

% Outputs: kp_time, kp_index

% loads Kp from Jan 1932 to the most recent update.

% kp_time - matlab serial date number
% kp_index - Kp index in x10 format (OMNI)

% The Kp times here are centered on the 3-hr interval of interest !!!!!!
% this is done so that interpolation routines using nearest neighbour will
% find the correct Kp index for the period of interest.

%% this Kp file is made from a script:
% yssvnl.igpp.ucla.edu:/data/Kp/Kp_archive/Process_Kp

% Written by Adam Kellerman, Jan 2013
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Kp=Load_kp

kpfile = [getenv('FC_DATA_DIR'),'/Kp/Kp_archive/kp_all.mat'];
Kp=load(kpfile);
%fprintf('Note that Kp times are centered on each 3-hr interval\n');

