% run VERB to create the grid file (it is supposed to fail)
%
% written by A. C. Kellerman

%% parameters structure:
function VERB_dummy(fcopt)

    steps=1;
    fid = fopen([fcopt.simulation_dir,'Parameters.ini'], 'w');
    fprintf(fid, ['timeStep = ', num2str(fcopt.timestep), '\n']);
    fprintf(fid, ['nDays = ', num2str(fcopt.timestep/24), '\n']);
    fprintf(fid, ['general_Output_parameters.iterStep = ',num2str(steps), '\n']);

    fprintf(fid, 'useKp = constant\n');
    fprintf(fid, ['constKp = 2\n']);

    fprintf(fid, 'usebf = constant\n');
    fprintf(fid, ['constKp = 2\n']);

    fprintf(fid, ['localDiffusionsGrid_L.size = ', num2str(fcopt.NL), '\n']);
    fprintf(fid, ['localDiffusionsGrid_L.min = ', num2str(fcopt.L_min), '\n']);
    fprintf(fid, ['localDiffusionsGrid_L.max = ', num2str(fcopt.L_max), '\n']);

    fprintf(fid, ['localDiffusionsGrid_epc.size = ', num2str(fcopt.NE), '\n']);
    fprintf(fid, ['localDiffusionsGrid_epc.min = ', num2str(fcopt.E_min), '\n']);
    fprintf(fid, ['localDiffusionsGrid_epc.max = ', num2str(fcopt.E_max), '\n']);

    fprintf(fid, ['localDiffusionsGrid_alpha.size = ', num2str(fcopt.NA), '\n']);
    fprintf(fid, ['localDiffusionsGrid_alpha.min = ', num2str(fcopt.a_min), '\n']);
    fprintf(fid, ['localDiffusionsGrid_alpha.max = ', num2str(fcopt.a_max), '\n']);
switch fcopt.upper_L
    case 'const0'
        fprintf(fid, ['L_UpperBoundaryCondition.type =  BCT_CONSTANT_VALUE\n']);
        fprintf(fid, ['L_UpperBoundaryCondition.value =  0\n']);  
    case 'Neuman'
        fprintf(fid, ['L_UpperBoundaryCondition.type =  BCT_CONSTANT_DERIVATIVE\n']);
        fprintf(fid, ['L_UpperBoundaryCondition.value =  0\n']);
    otherwise    
       fprintf(fid, ['L_UpperBoundaryCondition.type =  BCT_CONSTANT_PSD\n']); 
end
   % fprintf(fid, ['L_UpperBoundaryCondition.type =  BCT_CONSTANT_PSD\n']);
    fprintf(fid, ['pc_LowerBoundaryCondition.type = BCT_CONSTANT_PSD\n']); 

    fprintf(fid, ['alpha_UpperBoundaryCondition.type = BCT_CONSTANT_DERIVATIVE\n']);
    fprintf(fid, ['alpha_UpperBoundaryCondition.value = 0\n']);

    fprintf(fid, ['psdRadialDiffusion.initial_PSD_Type = IPSDT_STEADY_STATE\n']);
    fprintf(fid, ['psdRadialDiffusion.initial_PSD_Kp0 = 2\n']); %some base value to use throughout
    fprintf(fid, ['outputModelMatrix = false\n']);
    fprintf(fid, ['solveMatrix = true\n']);

    fprintf(fid, 'localDiffusionsGrid_alpha.useLogScale = No\n'); %default

    fclose(fid);

%    if fcopt.Dxx_opt == 0
%        system(['cat ', 'Parameters_DAonestep_Neumann.ini Dxx_Fa.tmp >> ',...
%            fcopt.simulation_dir,'Parameters.ini']);
%        fprintf('Computing grid and FA Dxx...');
%    else
        system(['cat ', 'Parameters_DAonestep_Neumann.ini Dxx_Full.tmp >> ',...
            fcopt.simulation_dir,'Parameters.ini']);
        fprintf('Computing grid...');
%    end 

%% time and run VERB code
    cwd = pwd; %get current working directory

    cd(fcopt.simulation_dir); %move to simulation directory
    fprintf('VERB executible: %s\n',fcopt.verb_exe_name);
    %system(['./',fcopt.verb_exe_name]); %should show 'crit error'
    % note that the code is supposed to fail here, we just want the grid
    [~,~] = system(['./',fcopt.verb_exe_name]);
        
    fprintf('done.\n');
    cd(cwd); 
