% written by A. C. Kellerman

function [Kp,Kpsep] = get_Kp2(varargin)

ttime = [];
tdat = [];

use_input_time=false;
if nargin > 0
    for it=1:1:nargin
        if strcmp(varargin(it), 'time')
            use_input_time=true;
            it=it+1;
            input_time=varargin(it)
        end
    end
end

if use_input_time
    stime=time(1);
    etime=time(end);
else
    stime=0;
    etime=now+5;
end
Kp=Load_kp;

okidx = find(Kp.kp_time >= stime & Kp.kp_time < etime);

if ~isempty(okidx)
    Kp.kp_time = Kp.kp_time(okidx);
    Kp.kp_index = Kp.kp_index(okidx) ./ 10;
else
    error('no valid kp for current time')
end
