% data assimilative forecast code:

% runs VERB in one step mode with constant boundary conditions but assimilates data
% on each of the three diffusion operations.

% firsr we must load initial condition from a special DA_init_file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [omat,mathash] = get_matrices(fcopt,PSD,Kp_sim,Lpp_sim,mp_set,old_mathash)

mathash = create_matr_hash(fcopt,Kp_sim,Lpp_sim,mp_set);
matrices_file = [fcopt.simulation_dir,'DiffMat/',mathash,'.mat'];
if ~strcmp(old_mathash,mathash);
    grd_fck = dir(matrices_file);
    matr_ok = false;
    if ~isempty(grd_fck)
        fprintf('loading matrices for Kp=%s...',num2str(Kp_sim,2));
        load(matrices_file);
        sz=size(omat.alpha_matr_C);
        if sz(1) == fcopt.NL && sz(2) == fcopt.NE && sz(3) == fcopt.NA
            matr_ok = true;
            fprintf('ok\n');
        else 
            fprintf('matrix size mismatch\n');
        end  
    end  
    if ~matr_ok    
        omat = run_VERB_fc(fcopt,PSD,Kp_sim,Lpp_sim,mp_set);
        %run_VERB_loaddxx    
        save(matrices_file,'omat');
    end  
else
    omat = [];
end

