% Initial Directories

% Written by Adam Kellerman
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% options:
%    'set_numwrk', numwkr - setups up the num workers flag for parallel processing

function Ini_dirs(varargin)

global dp_dirs

set_par = false;
if nargin > 0
    for it=1:1:nargin-1
        if strcmp(varargin(it),'set_numwrk')
            set_par = true;
            it = it+1;
            numwrk = varargin{it};
        end
    end
end

if set_par
    fprintf('setting NumWorkers to: %i\n',numwrk);
    try
        c = parcluster('local');
        c.NumWorkers=numwrk;
    catch end 
end
%where the data processing code lives
dp_dirs.data_org_path=[getenv('DATA_ORG_DIR'),'/'];

% where the spacecraft data are
dp_dirs.spc_data_dir=[getenv('SAT_DATA_DIR'),'/'];

% where the NASA matlab cdf patch is installed:
%addpath('/usr/lib/matlab/matlab_cdf363_patch-64');
%addpath('/usr/lib/matlab/matlab_cdf364_patch-64');

% where the IRBEM matlab files are installed
if (~isdeployed)
    addpath([getenv('IRBEM_CODE_DIR'),'/matlab/']);
end
