
%%% Compute the sample cross correlation or cross covariance of
%%% (Xt, Xt+l) and (Yt, Yt+l) as a function of the lag (l).

function ccv= crosscov(X,Y,Lag)
   nX = length(X);
   nnX = find(~isnan(X));
   nX2 = length(nnX);

   nY = length(Y);
   nnY=find(~isnan(Y));
   nY2 = length(nnY);
   
   
   if (nX ~= nY) 
       Error_Mes_Size= 'X and Y arrays must have the same number of elements'
   end
   
    if (nX < 2) 
        Error_Mes_Num = 'X and Y arrays must contain 2 or more elements.'
    end
       
    Xd = X; % - nansum(X)/nX2; %%%Deviations
    Yd = Y; %- nansum(Y)/nY2;
    
    nLag = length(Lag);

    
      for k = 1:nLag 
          if (Lag(k)>=0) 
                    part1 =Xd(1:nX - Lag(k))';
                    part2 = Yd(Lag(k)+1:nX)';
                    %Cross(k) = nansum(part1.*part2);
                    var = part1.*part2;
                    zz=find(~isnan(var));
                    Cross(k) = nansum(part1.*part2)./length(zz);
          else 
                    part1 =Yd(1:nX  + Lag(k))';
                    part2 = Yd(-Lag(k)+1:nX)';
                    var = part1.*part2;
                    zz=find(~isnan(var));
                    Cross(k) = nansum(part1.*part2)./length(zz);
          end
      end
        
    %%% Cross = Cross/sqrt( sum(Xd.^2)*sum(Yd.^2));
         %Cross = Cross/nX2;
        
  ccv = Cross;
      
end 
