function [flux_out] = func_flux_interp_e_a(flux, ech, eqpa, set_ech, set_pa)

szmu =size(InvMu);
nT = szmu(1);
newmu = permute(InvMu, [3 1 2]);
newpsd = permute(PSD, [3 1 2]);

nmu = length(muvals);
nk = length(kvals);
clear InvMu PSD

%time, nk, nmu (changed at end of script to  be time, nmu, nk
flux_out = nan(nT,nk,nmu);

lstar_out = nan(nT,nk);

tic
parfor it=1:nT
    if rem(it,1000) == 0
        fprintf('%s\n',[num2str(it),'/',num2str(szmu(1))])
    end
    psd_it = nan(nk,nmu);
    Lstart = Lstar(it,:);
    
    for ik=1:nk
        kset = kvals(ik);
        
        tmp_K = InvK(it,:);
        tmp_psd = squeeze(newpsd(:,it,:));
        tmp_mu = squeeze(newmu(:,it,:));
        
        notnank = find(~isnan(tmp_K));
        [uniqk,ia,ic] = unique(tmp_K(notnank));
        %notnank = (~isnan(tmp_K));
        if length(notnank) > 1 && length(uniqk) > 1
            %if sum(notnank) > 1
            if length(uniqk) < length(notnank) % then we have repetitions
                % unique sorts in acending order so we need to flip it
                utmp_K = fliplr(uniqk);
                utmp_psd = tmp_psd(notnank(fliplr(ia)),:);
                utmp_mu= tmp_mu(notnank(fliplr(ia)),:);
            else
                utmp_K = tmp_K(notnank);
                utmp_psd = tmp_psd(notnank,:);
                utmp_mu= tmp_mu(notnank,:);
            end
                
            psd_at_fixedK = exp(interp1(utmp_K.^(1/3),...
                log(utmp_psd),kset.^(1/3),'linear',NaN));
            %size nk,nmu
            
            muvals_at_fixedK = exp(interp1(utmp_K.^(1/3),...
            log(utmp_mu),kset.^(1/3),'linear'));
            %size nk,nmu
            
            lstar_out(it,ik) = interp1(utmp_K.^(1/3),...
                Lstar(it,notnank).^(1/3),kset.^(1/3),'linear').^3;
            notnan = find(~isnan(psd_at_fixedK) & ~isnan(muvals_at_fixedK));
            if length(notnan) > 1
                [~,inxmu,~] = unique(muvals_at_fixedK(notnan));
                if length(inxmu) > 1
                    %psd_it(ik,:)=exp(interp1(muvals_at_fixedK(notnan(inxmu)),...
                    %    log(psd_at_fixedK(notnan(inxmu))),muvals,'linear', NaN));
                    psd_it(ik,:)=10.^(interp1(log10(muvals_at_fixedK(notnan(inxmu))),...
                        log10(psd_at_fixedK(notnan(inxmu))),log10(muvals),'linear', NaN));
                end
            end
        end
    end
    flux_out(it,:,:) = psd_it;
end

%reorder time, mu, k:
flux_out = permute(flux_out, [1 3 2]);
toc
