function [maginput] = func_make_maginput_matlab(matlabd)

global Satellite_data_dir

nT = length(matlabd);

st = matlabd(1);
et = matlabd(end);

[syr,~,~,~,~,~] = datevec(st);
[eyr,~,~,~,~,~] = datevec(et);

if syr ~= eyr
    'need to implement concat load omnimin here'
    pause
    return
end
[sw_data, sw_matlabd]=get_omnimin(syr);

maginput=nan(25,nT);

%kp
Load_kp
kp = interp1(kp_time, kp_index,matlabd, 'nearest');
maginput(1,:) = kp;

dt = median(diff(matlabd))/2.;

tmplsw = zeros(7,nT)+NaN;
parfor it=1:nT
    svar=0;
    zz=find(sw_matlabd >= matlabd(it)-dt & sw_matlabd < matlabd(it)+dt);
    if ~isempty(zz)
        tmpvars = zeros(7,1)+NaN;
        for ivar=1:7

            if ivar == 7
                svar=15; %Bx, GSM

            elseif ivar == 5
                svar=18; %By, GSM

            elseif ivar == 6
                svar=19; %Bz, GSM

            elseif ivar == 3
                svar=22; %Flow speed, km/s

            elseif ivar == 2
                svar=26; %Proton Density, n/cc

            elseif ivar == 4
                svar=28; %Flow Pressure, nPa

            elseif ivar == 1
                svar=48; %Sym-H converted to Dst 
            end

            tmpvals = sw_data(zz,svar);
            zz2=find(~isnan(tmpvals) & tmpvals ~=1e-32);
            if ~isempty(zz2)
                %lsw_dat(it,ivar+11) = mean(tmpvals(zz2));
                tmpvars(ivar) = mean(tmpvals(zz2));
            end
        end
        tmplsw(:,it) = tmpvars;
    end
end
maginput(2:7,:) = tmplsw(1:6,:);
clear tmplsw

tmplsw = zeros(1,nT);
parfor it=1:nT
    zz=find(sw_matlabd >= matlabd(it)-dt & sw_matlabd < matlabd(it)+dt);
    if ~isempty(zz)
        tmpvals = sw_data(zz,39); %AL
        zz2=find(~isnan(tmpvals) & tmpvals ~=1e-32);
        if ~isempty(zz2)
            tmplsw(it) = mean(tmpvals(zz2));
        end
    end
end
maginput(17,:) = tmplsw;
clear tmplsw

tmplsw = zeros(9,1)+NaN;
parfor it=1:nT
    svar=0
    zz=find(sw_matlabd >= matlabd(it)-dt & sw_matlabd < matlabd(it)+dt);
    if ~isempty(zz)
        tmpvars=zeros(9,1)+NaN;
        for ivar=1:9
            svar=48+ivar;
            tmpval = sw_data(zz,svar);
            zz2=find(~isnan(tmpval) & tmpval ~=1e-32);
            if ~isempty(zz2)
                %                   lsw_dat(it,ivar) = mean(tmpval(zz2));
                tmpvars(ivar) = mean(tmpval(zz2));
            end
        end
        tmplsw(:,it) = tmpvars;
    end
end
maginput(8:16,:) = tmplsw;
maginput=double(maginput);
clear tmplsw
