% get mf text from input, or vice versa
% Author A. Kellerman
% additional options
% 'kext' - input is kext - irbem external field specification
% 'mfmtxt' - input is mfmtxt e.g. 'T89', must match standard formats for files
function [output] = get_mfm(input,varargin)

%default, input is kext
input_kext = true;

if nargin > 1
    for it = 1:1:nargin-1
        if strcmp(varargin(it),'kext')
            input_kext = true;
        elseif strcmp(varargin(it),'mfmtxt')
            input_kext = false;
        end
    end
end


if (input_kext)
    switch(input)
        case 0
            output = 'IGRF';
        case 4
            output = 'T89';
        case 5
            output = 'OP77';
        case 11
            output = 'T04s';
        otherwise
            error('no mfmtxt for kext=%i specified, insert here',input)
    end
else
    switch(input)
        case 'IGRF'
            output = 0;
        case 'T89'
            output = 4;
        case 'OP77'        
            output = 5;
        case 'T04s'
            output = 11;
        otherwise
            error('no kext for mfmtxt=%s specified, insert here',input)
    end
end
