%%
%
%
% Written by Adam Kellerman, Feb 2013
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [pos] = get_tipsod_pos(mission,spc,coord,time_in);

global dp_dirs

% no goes, it's completed from .mat files in Post...LSW routine

oyr=-1;
tip_time=[];
tip_pos=[];

for it=1:length(time_in);
    [tyr,tmo,~,~,~,~] = datevec(time_in(it));
    if tyr ~= oyr
        oyr=tyr;

        file = [dp_dirs.spc_data_dir, mission, '/',spc,'/TIPSOD_Position/', spc,'_pos',coord,'_', num2str(tyr), '.txt'];
        files=dir(file);
        if ~isempty(files)
            %tpos_data = importdata(file, 31);
            fid = fopen(file, 'rt');
            %header = textscan(fid,'%s',31);

            %expanded format
            C = textscan(fid,'%d/%d/%d %d:%d:%d%f%f%f','Delimiter',['\t']);                
            [yr, mo, dy, hr, mt, sc, x, y, z] = deal(C{:});
            fclose(fid);
            if length(yr) == 1 % then use other format
                fid = fopen(file, 'rt');
                C = textscan(fid,'%d/%d/%d %d:%d%f%f%f','Delimiter',['\t']);
                fclose(fid);
                [yr, mo, dy, hr, mt, x, y, z] = deal(C{:});
            end

            yr=yr+floor(tyr/100)*100;
            
            matlab_day=datenum(double(yr), double(mo), double(dy), double(hr), double(mt), 0);
            tip_time = cat(1,tip_time,matlab_day);
            tip_pos = cat(1,tip_pos,cat(2,x,y,z));
        end
    end
end 
% we have all the position data now
st= time_in(1);
et=time_in(end);
nt = length(tip_time);
zz=find(tip_time >= st & tip_time <= et);
if ~isempty(zz) % then we'll get some points
    pos = interp1(tip_time,tip_pos,time_in,'linear',NaN);
else
    pos=nan(length(time_in),3);
end
