function [flux_time,Flux,xGEO,ech,local_pitch_angles] = nflux_to_flux(nflux_file);

% hi res files do not depend on the pitch angle of the nflux files so we just need to apply the MeV flag here

load(nflux_file);

Flux = localflux;
clear localflux

nt = length(flux_time);

if size(local_pitch_angles,2) == nt 
    local_pitch_angles = local_pitch_angles';
elseif size(local_pitch_angles,1) > 1 && ...
    size(local_pitch_angles,1) < nt
    local_pitch_angles = local_pitch_angles';
end                                
na = size(local_pitch_angles,2);

if (MeV)  %if units are in MeV
    Flux=Flux/1000; %convert to /(cm^2.s.sr.keV)
end

% let's convert position data to xGEO
A = exist('xGEO','var');
if A ~= 1
    fprintf('determining position type...');
    B = exist('xGDZ','var');
    C = exist('xGSM','var');
    D = exist('xGSE','var');
    E = exist('xSM','var');
    F = exist('xGEI','var');
    G = exist('xMAG','var');
    H = exist('xRLL','var');
    if B == 1
        coord = 'xGDZ';
        fprintf('converting %s to xGEO\n',coord)
        xGEO = onera_desp_lib_coord_trans(xGDZ,'GDZ2GEO',flux_time);
    elseif C == 1
        coord = 'xGSM';
        fprintf('converting %s to xGEO\n',coord)
        xGEO = onera_desp_lib_coord_trans(xGSM,'GSM2GEO',flux_time);
    elseif D == 1
        coord = 'xGSE';
        fprintf('converting %s to xGEO\n',coord)
        xGEO = onera_desp_lib_coord_trans(xGSE,'GSE2GEO',flux_time);
    elseif E == 1
        coord = 'xSM';
        fprintf('converting %s to xGEO\n',coord)
        xGEO = onera_desp_lib_coord_trans(xSM,'SM2GEO',flux_time);
    elseif F == 1
        coord = 'xGEI';
        fprintf('converting %s to xGEO\n',coord)
        xGEO = onera_desp_lib_coord_trans(xGEI,'GEI2GEO',flux_time);
    elseif G == 1
        coord = 'xMAG';
        fprintf('converting %s to xGEO\n',coord)
        xGEO = onera_desp_lib_coord_trans(xMAG,'MAG2GEO',flux_time);
    elseif H == 1
        coord = 'xRLL';
        fprintf('converting %s to xGEO\n',coord)
        xGEO = onera_desp_lib_coord_trans(xRLL,'RLL2GEO',flux_time);
    else
        who
        error(['unrecognized or non-existant position data,',...
                'should be a variable of the form: xZZZ'])
    end
end
