clear

addpath([getenv('DATA_ORG_DIR'),'/Functions/']);
Ini_dirs('set_numwrk',8);

global dp_dirs

close all
f1 =figure('renderer','painters',...
            'DefaultAxesFontsize',14,...
            'DefaultAxesFontWeight','bold',...
            'Color',[0 0 0],'visible','off');

set(f1,'pos',[1280 0 1600 1200])
set(f1,'paperpositionmode','auto');

fig_dir = [getenv('DATA_ORG_DIR'),'/figures/'];

use_doy = false; %can specify start and end times in doy format

if use_doy
    styr=2013
    enyr=2013

    stdoy=75.5 %QARMB March
    endoy=77.5 

    %stdoy=151.5 %QARMB June
    %endoy=153.5 

    %stdoy=261.5 %QARMB Sept_I    
    %endoy=263.5 

    stdoy=266.5 %QARMB Sept_II
    endoy=268.5 


    st_matlabd = doy2date(styr,stdoy);
    en_matlabd = doy2date(enyr,endoy);

    [styr,stmo,stdy,sthr,~,~] = datevec(st_matlabd);
    [enyr,enmo,endy,enhr,~,~] = datevec(en_matlabd);
else
    if (false)
        styr=2013
        stmo=3
        stdy=1
        sthr=0

        enyr=2013
        enmo=3
        endy=31
        enhr=0
    else
        styr=2015
        stmo=7
        stdy=1
        sthr=0

        enyr=2015
        enmo=7
        endy=31
        enhr=0
    end
    styr=2013;
    stmo=9;
    stdy=23;
    sthr=12;
    enyr=2013;
    enmo=9;
    endy=25;
    enhr=12;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% NAME FOR FIGURE %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure_txt='QARBM_Sept23_cal'

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%use_real_invmu = false;
use_black_bg = true;

mageis_nocorr = true; %use NoCorr files?
cluster_corr = true; %use corrected Cluster files?
use_calib = true; %use calibration where appropriate/possible?

n_string = 'n4_4';

%mfm='T89';
%mfmtxt='T89';

%mfm='T04s';
%mfmtxt='TS05';

mfm='T01s';
mfmtxt='T01s';

%mfm='TS07Dmid15'
%mfmtxt='TS07D'

version='_ver4';
%kvals = [0.001 0.01 0.1145];
kvals = [0.1];
%kvals = [0.3];

%mus = [200 500 700 1000 1500 2000 2500 3000 3500 4000]
%mus = [50 100 200 300 400 500 700 1000 1600 3400]; % 1000 1500 2000 2500 3000 3500 4000]
%mus = [116 152 200 2879]; % 1000 1500 2000 2500 3000 3500 4000]
mus = [700]; % 1000 1500 2000 2500 3000 3500 4000]

yrng = [1 7]; %range in L*
lvals = [3.5 5.5]; % dashed lines?

overplotL = true;

% values may be overwritten, see automated values below
c_min = -4; c_max = -1 ; %200, 0.05

use_nobsat = 0;
if use_nobsat == 1
    pref='noBsat_'

else
    pref=''
end

sd=datenum(styr, stmo, stdy, sthr, 0, 0)
ed=datenum(enyr, enmo, endy, enhr, 0, 0)

%% Time ticks for axis:

time_ticks = sd:12/24:ed;
%time_ticks = sd:10:ed;

%monthly time ticks:
if (false)
    time_ticks = [];
    cdate = sd;
    while cdate < ed
    %    time_ticks = cat(1,time_ticks,cdate);
        [yr,mo,~] = datevec(cdate);
        mo = mo + 1;
        if mo > 12
            mo = 1;
            yr = yr + 1;
        end
        cdate = datenum(yr,mo,1);
    end
end
xrng=[sd ed];

if strcmp(version,'_ver4')
    v4sw=true;
else
    v4sw=false;
end

% if you have the parallel computing package
try
    parpool(4);
catch end

nk = length(kvals);
for ik=1:nk
    target_K = kvals(ik);
    for use_real_invmu=1:1 %can do both modeled and measured B
        if use_real_invmu
            invmutxt = 'realInvMu';
            mutittxt = 'real'
            rbtxt='_real';
        else
            invmutxt = 'modelInvMu';
            mutittxt = 'modeled'
            rbtxt='';
        end

        nmu = length(mus);
        for imu = 1:nmu
            sat_time = [];
            sat_psd = [];
            sat_lstar = [];
            sat_mlt = [];
            sat_amax = [];
            target_mu = mus(imu);
            %man reply after review
            set_caxis = false;
            
            %if abs(target_K - 0.11) < 1e-7
            if target_K >= 0.1
                if target_mu == 50; c_min = -4.5; c_max = -1 ; end; %50, 0.11
                if target_mu == 100; c_min = -5.5; c_max = -2 ; end; %100, 0.11
                if target_mu == 200; c_min = -6; c_max = -3 ; end; %200, 0.11
                if target_mu == 300; c_min = -6; c_max = -3 ; end; %200, 0.11
                if target_mu == 400; c_min = -8; c_max = -4 ; end; %500, 0.11
                if target_mu == 500; c_min = -8; c_max = -4.3 ; end; %500, 0.11
                if target_mu == 700; c_min = -8; c_max = -5 ; end; %700, 0.11
                if target_mu == 1000; c_min = -8.5; c_max = -5.5 ; end;  %1000, 0.11
                if target_mu == 1500; c_min = -9; c_max = -5 ; end; %1500, 0.11
                if target_mu == 2000; c_min = -9.5; c_max = -6.5 ; end; %2000, 0.11
                if target_mu == 2500; c_min = -9; c_max = -5 ; end; %2500, 0.11
                if target_mu == 3000; c_min = -10; c_max = -7 ; end; %3000, 0.11
                if target_mu == 3400; c_min = -10.5; c_max = -6 ; end; %3500, 0.11
                if target_mu == 3500; c_min = -10.5; c_max = -6 ; end; %3500, 0.11
                if target_mu == 4000; c_min = -11; c_max = -8 ; end; %4000, 0.11
                set_caxis = true;
            end
            if abs(target_K - 0.01) < 1e-7
                if target_mu == 200; c_min = -5; c_max = -2 ; end; %200, 0.11
                if target_mu == 500; c_min = -7; c_max = -3 ; end; %500, 0.11
                if target_mu == 700; c_min = -7; c_max = -4 ; end; %700, 0.11
                if target_mu == 1000; c_min = -7.5; c_max = -4.5 ; end;  %1000, 0.11
                if target_mu == 1500; c_min = -8; c_max = -5 ; end; %1500, 0.11
                if target_mu == 2000; c_min = -8.5; c_max = -5.5 ; end; %2000, 0.11
                if target_mu == 2500; c_min = -9; c_max = -6 ; end; %2500, 0.11
                if target_mu == 3000; c_min = -9; c_max = -6 ; end; %3000, 0.11
                if target_mu == 3500; c_min = -9.5; c_max = -6.5 ; end; %3500, 0.11
                if target_mu == 4000; c_min = -10; c_max = -7 ; end; %4000, 0.11
                set_caxis = true;
            end

            %isats = [1 2 3 4 5 6 7 11 12];
            %isats = [1 2 3 4 5 6 7 11 12 13];
            %isats = [3 4 11 12];
            %isats = [1 2 3 4 11 12 13];
            %isats = [1 2 3 4 8 9 10 11 12 13];
            %isats = [1 2 8 9 10 11 12 13];
            %isats = [1 2 3 4 11 12 13];
            %isats = [1 2 11 12 13];
            %isats = [3 4 11 12 13];
            %isats = [14 15 16 17];
            %isats = [1 2 11 12 13];
            isats = [1 2 8 9 10 11 12 13 14 15 16 17];
            nisat = length(isats);
            if true
                for ii=1:nisat
                    isat = isats(ii);
                    calib=false;
                    if isat == 1
                        calib=true;
                        spc='rbspa';
                        if mageis_nocorr
                            instr='mageisNoCorr';
                        else
                            instr='mageis';
                        end
                        mission='RBSP';
                        calib=true;
                    end
                    if isat == 2
                        calib=true;
                        spc='rbspb';
                        if mageis_nocorr
                            instr='mageisNoCorr';
                        else
                            instr='mageis';
                        end
                        mission='RBSP';
                        calib=true;
                    end
                    if isat == 3
                        spc='rbspa';
                        instr='rept';
                        instr1=instr;
                        mission='RBSP';
                    end
                    if isat == 4
                        spc='rbspb';
                        instr='rept';
                        instr1=instr;
                        mission='RBSP';
                    end
                    if isat == 5
                        spc='THEMISa';
                        instr1='SST_FEDU';
                        instr=instr1;
                        mission='THEMIS';
                        calib=true;
                    end
                    if isat == 6
                        spc='THEMISd';
                        instr1='SST_FEDU';
                        instr=instr1;
                        mission='THEMIS';
                        calib=true;
                    end
                    if isat == 7
                        spc='THEMISe';
                        instr1='SST_FEDU';
                        instr=instr1;
                        mission='THEMIS';
                        calib=true;
                    end
                    if isat == 8
                        spc='THEMISa';
                        instr1='ESAandSSTFEDUcombined';
                        instr=instr1;
                        mission='THEMIS';
                        calib=true;
                    end
                    if isat == 9
                        spc='THEMISd';
                        instr1='ESAandSSTFEDUcombined';
                        instr=instr1;
                        mission='THEMIS';
                        calib=true;
                    end
                    if isat == 10
                        spc='THEMISe';
                        instr1='ESAandSSTFEDUcombined';
                        instr=instr1;
                        mission='THEMIS';
                        calib=true;
                    end
                    if isat == 11
                        spc='GOES13';
                        instr='MAGEDandEPEAD';
                        instr1=instr;
                        mission='GOES';
                        calib=true;
                    end
                    if isat == 12
                        spc='GOES14';
                        instr='MAGEDandEPEAD';
                        instr1=instr;
                        mission='GOES';
                        calib=true;
                    end
                    if isat == 13
                        spc='GOES15';
                        instr='MAGEDandEPEAD';
                        instr1=instr;
                        mission='GOES';
                        calib=true;
                    end
                    if isat == 14
                        spc='Cluster1';
                        if cluster_corr
                            instr='RAPIDCorr';
                        else
                            instr='RAPID';
                        end
                        instr1=instr;
                        mission='Cluster';
                        calib=false;
                    end
                    if isat == 15
                        spc='Cluster2';
                        if cluster_corr
                            instr='RAPIDCorr';
                        else
                            instr='RAPID';
                        end
                        instr1=instr;
                        mission='Cluster';
                        calib=false;
                    end
                    if isat == 16
                        spc='Cluster3';
                        if cluster_corr
                            instr='RAPIDCorr';
                        else
                            instr='RAPID';
                        end
                        instr1=instr;
                        mission='Cluster';
                        calib=false;
                    end
                    if isat == 17
                        spc='Cluster4';
                        if cluster_corr
                            instr='RAPIDCorr';
                        else
                            instr='RAPID';
                        end
                        instr1=instr;
                        mission='Cluster';
                        calib=false;
                    end
                    if ~use_calib
                        calib = false;
                    end
    
                    %calib=false;
                    spc_base_dir = [dp_dirs.spc_data_dir,mission,'/',spc,'/'];

                    fprintf('\n#############################################\n')
                    fprintf('%s %s %s\n',spc,instr,mfm);
                    mo=stmo;
                    yr=styr;
                    date = datenum(yr,mo,1);        
                    while date <= ed
                        dates=make_dates(yr,mo);
                        searchdir=[spc_base_dir,'Processed_Mat_Files/'];
                        
                        %alpha and energy
                        searchfile=[pref,spc,'_',instr,'_',dates,'_alpha_and_energy_',n_string,'_',mfm,version,'.mat'];
                        files=dir([searchdir,searchfile]);
                        if ~isempty(files)
                            load([searchdir,searchfile]);
                        else
                            break
                        end

                        %lstar
                        searchfile=[pref,spc,'_',instr,'_',dates,'_lstar_',n_string,'_',mfm,version,'.mat'];
                        files=dir([searchdir,searchfile]);
                        if ~isempty(files)
                            load([searchdir,searchfile]);
                        else
                            break
                        end

                        % invmu and k
                        searchfile=[pref,spc,'_',instr,'_',dates,'_invmu_and_invk_',n_string,'_',mfm,version,'.mat'];
                        files=dir([searchdir,searchfile]);
                        if ~isempty(files)
                            load([searchdir,searchfile]);
                        else
                            break
                        end

                        % invmu and k
                        searchfile=[pref,spc,'_',instr,'_',dates,'_real_invmu_and_alpha_',n_string,'_',mfm,version,'.mat'];
                        files=dir([searchdir,searchfile]);
                        if ~isempty(files)
                            load([searchdir,searchfile]);
                        else
                            break
                        end
                        
                        % mlt
                        searchfile=[pref,spc,'_',instr,'_',dates,'_mlt_',n_string,'_',mfm,version,'.mat'];
                        files=dir([searchdir,searchfile]);
                        if ~isempty(files)
                            load([searchdir,searchfile]);
                        else
                            break
                        end
                        
                        % psd 
                        if calib
                            calibtxt='_calibrated';
                        else
                            calibtxt='';
                        end
                        if v4sw && ~calib % if calib is true then psd is B-field model dependent
                            searchfile=[pref,spc,'_',instr,'_',dates,'_psd',version,calibtxt,'.mat'];
                        else
                            searchfile=[pref,spc,'_',instr,'_',dates,'_psd_',n_string,'_',mfm,version,rbtxt,calibtxt,'.mat'];
                        end

                        files=dir([searchdir,searchfile]);

                        if ~isempty(files);
                            load([searchdir,searchfile]);
                        else
                            break
                        end

                        zz=find(time >= sd & time <= ed);
                        time = time(zz);
                        PSD = PSD(zz,:,:);
                        if use_real_invmu
                            InvMu = InvMu_real(zz,:,:);
                        else
                            InvMu = InvMu(zz,:,:);
                        end
                        InvK = InvK(zz,:);
                        Lstar = Lstar(zz,:);
                        MLT = MLT(zz);
                        alpha_eq = alpha_eq_model(zz,:);

                        [PSD_out, lstar_out] = func_psd_interp_mu_k(PSD,InvMu,InvK,Lstar,target_mu,target_K);
                        if strcmp(instr,'SST_FEDU') || strcmp(instr,'ESAandSSTFEDUcombined')
                            zz = find(lstar_out < 6);
                            if ~isempty(zz)
                                PSD_out(zz) = NaN;
                            end
                        end
                        sat_time = cat(1,sat_time,time);
                        sat_psd = cat(1,sat_psd,PSD_out);
                        sat_lstar = cat(1,sat_lstar,lstar_out);
                        sat_mlt = cat(1,sat_mlt,MLT);
                        sat_amax = cat(1,sat_amax,nanmax(alpha_eq,2));
                        fprintf('%s ok\n',dates);

                        mo = mo+1;
                        if mo > 12
                            mo = 1;
                            yr=yr+1;
                        end
                        date = datenum(yr,mo,1);
                    end
                end
            end


            s1 = subplot(4,1,1:3);

            %set_mlt = 1;
            %inx_a = find(abs(rba_mageis_mlt - set_mlt) < 0.05);
            %length(inx_a)


            alpha_vals = LK2alpha(lvals,target_K);
            pc = mu2pc(lvals,target_mu,alpha_vals);

            epc = Kfunc(pc);

            Kp = Load_Kp;
            Kp.kp_index = Kp.kp_index/10;
            Lpp = 5.6 - 0.46 * Kp.kp_index;

            nn = find(~isnan(sat_psd));
            max_psd = nanmax(sat_psd);
            if (true)
                time = sat_time(nn);
                lstar = sat_lstar(nn);
                psd = sat_psd(nn);

                %save_file = [data_dir,pref,figure_txt,'PSD_Fixed_M',num2str(target_mu),'_K',num2str(target_K,3),'_',mfmtxt,'_',invmutxt,'.mat'];
                %save(save_file,'time','lstar','psd');

                scatter(sat_time(nn),sat_lstar(nn),20,log10(sat_psd(nn)),'o','filled');
                maxc = max(log10(sat_psd(nn)));
                hold on
            elseif false
                zz=find(~isnan(sat_lstar) & ~isnan(sat_psd));

                tmesh = nanmin(sat_time):1/2:nanmax(sat_time);
                lmesh = 3:0.1:7;
                [xi,yi] = meshgrid(tmesh,lmesh);
                zi = griddata(sat_time(zz),sat_lstar(zz),log10(sat_psd(zz)),xi,yi);
                [C,h] = contourf(xi,yi,zi,100);
                h.LineStyle = 'none';

                hold on
            else
                dt = 12/24;
                newtime = (min(sat_time)+dt):dt:max(sat_time);
                dl = 0.1;
                newl = yrng(1)+dl:dl:yrng(end);
                nl = length(newl);
                nt = length(newtime);

                newpsd = nan(nl,nt);
                xi = nan(nl,nt);
                yi = nan(nl,nt);
                
                for it=1:nt
                    loop_counter(it,nt,'tput','mod',10);
                    for il=1:nl
                        zz = find(sat_time >= newtime(it)-dt/2 & sat_time < newtime(it)+dt/2 & ...
                            sat_lstar >= newl(il) - dl/2 & sat_lstar < newl(il) + dl/2); 
                        if ~isempty(zz)
                            newpsd(il,it) = nanmean(sat_psd(zz));
                        end
                        xi(il,it) = newtime(it);
                        yi(il,it) = newl(il);
                    end
                end
                maxc = nanmax(log10(newpsd(:)));
                pcolor(newtime-dt,newl-dl,log10(newpsd))    
                shading flat
                %colorbar
                %crng = caxis

                %pause
                %[C,h] = contourf(newtime,newl,log10(newpsd),100);

            % nn = find(~isnan(newpsd));
            % zi = griddata(xi(nn),yi(nn),log10(newpsd(nn)),xi,yi,'natural');
            % zi(zi < c_min) = c_min;
            % zi(zi > c_max) = c_max;
                %[C,h] = contourf(xi,yi,zi,100);
                %h.LineStyle = 'none';
                %pcolor(newtime-dt,newl-dl,zi)    
                %shading flat
                %colorbar
                %caxis(crng)

                hold on
            end

            if use_black_bg
                colorset1 = 'w';
                colorset2 = 'k';
            else
                colorset1 = 'k';
                colorset2 = 'w';
            end

            %save('figure_data.mat','sat_time','sat_lstar','sat_psd');

            %nn = find(~isnan(rba_rept_psd));
            %scatter(rba_rept_time(nn),rba_rept_L(nn),20,log10(rba_rept_psd(nn)),'filled');
            %hold on
            %nn = find(~isnan(rbb_rept_psd));
            %scatter(rbb_rept_time(nn),rbb_rept_L(nn),20,log10(rbb_rept_psd(nn)),'filled');
            %max_psd = nanmax(rbb_rept_psd(nn));

            
            dx = xrng(2) - xrng(1);
            if (overplotL)
                for il=1:length(lvals)
                    plot([xrng(1) xrng(2)],lvals(il).*[1 1],colorset1,'LineWidth',2);
                    plot([xrng(1) xrng(2)],lvals(il).*[1 1],'--','LineWidth',2,'Color',colorset2);
                    text(xrng(1)+dx/40,lvals(il),[num2str(epc(il),2),' MeV, ',num2str(alpha_vals(il).*180/pi,3),'^o'],...
                        'BackgroundColor',colorset2,'verticalalignment','middle');
                end
            end

            %plot(kp_time,Lpp,'--w');

            hold off
            xlim(xrng);
            %scatter(g13_time,g13_L,20,log10(g13_psd),'filled');
            %scatter(g15_time,g15_L,20,log10(g15_psd),'filled');

            %cmap = fliplr(colormap(jet(256)));
            cmap = colormap(jet(256));

            cmap(1,:) = [0 0 0];
            colormap(cmap)

            %caxis([-10.5 -4.0]); %700, 0.05 %THEM/RB

            c_max = maxc;
            c_min = c_max - 3;
            %c_max = -2.5;
            %c_min = -6;

            if set_caxis
                caxis([c_min c_max]);
            end


            ylabel(['L*,',mfmtxt]);
            c1 = colorbar('East')
            c1.Label.String = 'log_{10}PSD, (c/cm/MeV)^3';
            %c1.Label.BackgroundColor = 'k'
            c1.FontSize = 14;
            c1.FontWeight = 'bold';

            c1.Color = colorset1;
            whitebg(colorset2);

            set(gca,'XTick',time_ticks);
            set(gca,'XTickLabel',[],'Layer','top');
            %datetick('x','keeplimits','keepticks');

            %title(['GOES & Van Allen Probe Data, \mu = ',num2str(target_mu),' MeV/G, K = ',...
            %    num2str(target_K,3),' G^{0.5}R_E'],'FontWeight','bold','FontSize',12,'Color','w');
            %title(['RBSP, GOES, and THEMIS Data, \mu = ',num2str(target_mu),' MeV/G, K = ',...
            title(['PSD, ',mutittxt,' \mu = ',num2str(target_mu),' MeV/G, K = ',...
                num2str(target_K,3),' G^{0.5}R_E'],'FontWeight','bold','FontSize',14,'Color',colorset1);

            ylim(yrng);

            s2 = subplot(4,1,4);

            bar(Kp.kp_time,Kp.kp_index,'g');
            xlim(xrng);
            set(gca,'XTick',time_ticks);
            %datetick('x','yyyy-mmm','keeplimits','keepticks');
            %datetick('x','mm/dd','keeplimits','keepticks');
            datetick('x','mmm-dd, HH:MM','keeplimits','keepticks');
            %datetick('x','HH:MM','keeplimits','keepticks');
            whitebg(colorset2);
            ylabel('Kp');
            set(gcf,'inverthardcopy','off');
            c1.Position(1) = c1.Position(1) + 0.1;
            drawnow

            saveas(gcf,[fig_dir,pref,figure_txt,'PSD_Fixed_M',num2str(target_mu),'_K',num2str(target_K,3),'_',mfmtxt,'_',invmutxt,'.png'],'png');
        end
    end
end
