#!/bin/bash
# title: Download POES data 
# author: Adam Kellerman
# 

get_all_data=0 # 0 - get only data for 'year' below, 1 - get all data available

year=2016 #there is not enough space to download it all, so just get one year at a time

p_dir=$SAT_DATA_DIR/POES/OriginalData/full
mkdir -p $p_dir

logfile=$HOME/log/poes_download.log

echo "Start: $(date)" >> $logfile

if [ $get_all_data == 1 ]; then
    wget -N -P $p_dir -r -np -nH --cut-dir=7 -e robots=off --reject "index.html*","*.pdf" https://satdat.ngdc.noaa.gov/sem/poes/data/processed/ngdc/uncorrected/full/ -a $logfile -nv
else
    wget -N -P $p_dir -r -np -nH --cut-dir=7 -e robots=off --reject "index.html*","*.pdf" https://satdat.ngdc.noaa.gov/sem/poes/data/processed/ngdc/uncorrected/full/$year/ -a $logfile -nv
fi

echo "End: $(date)" >> $logfile
